<?php
/**
 * @file transport_retrieve_service.inc
 * Provides services callbacks for transport retrieval.
 */

/**
 * Check if the user has the permission to access the service.
 *
 * TODO, somehow :/
 * We can't know at this point whether the user has the permission to create
 * nodes of the type that Transport module will retrieve.
 * Failure may happen further down the line...
 *
 * @return
 *   Boolean. TRUE if the user has view access.
 */
function transport_retrieve_service_get_access() {
  return user_access('access transport service');
}

/**
 * Service callback.
 *
 * @param $connection_name
 *  The machine name of a connection.
 * @param $entities
 *  A list of entities in the format used by TransportControllerRetriever::beginRetrieval().
 *
 * @return
 *  TRUE for success, FALSE for failure.
 */
function transport_retrieve_service_retrieve($connection_name, $entities) {
  // Really bogus: sleep for long enough for the remote site to
  // save its image, etc etc.
  sleep(2); 
  
  // Get the connection based on the give machine name.
  $connection = clients_connection_load($connection_name);
  
  // Create our transport controller.
  // Define an arbitrary name to identify the source.
  $source_name = "transport-$connection_name";
  $options = array();
  $transport_controller = new TransportControllerRetriever($source_name, $connection, $options);
  
  // Start the process.
  $processed_list = $transport_controller->beginRetrieval($entities); 
 
  return TRUE; 
}
